From d8a6fd1177c57ba797c929acd7e49c8a98c1f60b Mon Sep 17 00:00:00 2001
From: Wen Gong <wgong@codeaurora.org>
Date: Wed, 9 Sep 2020 17:23:52 +0800
Subject: [PATCH 169/173] ath11k: fix crash for recovery caused by "ath11k:
 setup REO for QCA6490"

Once RDDM happends, core restarts, need to init hal_rx_ops here since
ath11k_pci_probe is not called.

[  285.779906] ath11k_pci 0000:05:00.0: start to reset for rddm
[  376.998635] ath11k_pci 0000:05:00.0: Assign MSI to user: DP, num_vectors: 18, user_base_data: 14, base_vector: 14
[  376.998639] ath11k_pci 0000:05:00.0: ring not part of an ext_group; ring_type: 3,ring_num 0
[  376.998699] ath11k_pci 0000:05:00.0: Assign MSI to user: DP, num_vectors: 18, user_base_data: 14, base_vector: 14
[  376.998764] BUG: kernel NULL pointer dereference, address: 0000000000000000
[  376.998771] #PF: supervisor read access in kernel mode
[  376.998775] #PF: error_code(0x0000) - not-present page
[  376.998779] PGD 0 P4D 0
[  376.998787] Oops: 0000 [#1] SMP PTI
[  376.998796] CPU: 0 PID: 245 Comm: kworker/u16:2 Kdump: loaded Tainted: G        W  OE     5.7.0-rc7-wt-ath+ #3
[  376.998800] Hardware name: LENOVO 418065C/418065C, BIOS 83ET63WW (1.33 ) 07/29/2011
[  376.998829] Workqueue: ath11k_wq ath11k_core_restart [ath11k]
[  376.998855] RIP: 0010:ath11k_dp_alloc+0x4e2/0x5a0 [ath11k]
[  376.998862] Code: 87 29 c1 48 89 ef e8 dd c3 00 00 e9 6f fc ff ff 48 8b 85 88 80 00 00 8b b5 00 01 01 00 48 89 ef 48 8d 9d 78 12 00 00 45 31 f6 <48> 8b 00 e8 26 a7 99 ea 48 8b 85 e8 00 01 00 44 8b 38 49 c1 e7 05
[  376.998867] RSP: 0018:ffffbc92c040fdd8 EFLAGS: 00010246
[  376.998872] RAX: 0000000000000000 RBX: ffff98d77f121278 RCX: ffffffffc1289180
[  376.998876] RDX: ffffbc92c36b856c RSI: 0000000043214321 RDI: ffff98d77f120000
[  376.998879] RBP: ffff98d77f120000 R08: ffffbc92c040fd68 R09: ffffbc92c403b078
[  376.998883] R10: ffff98d780fc0000 R11: ffffffffacb98704 R12: ffff98d77f121018
[  376.998887] R13: ffff98d77f120ed8 R14: 0000000000000000 R15: 0000000000000000
[  376.998892] FS:  0000000000000000(0000) GS:ffff98d83a200000(0000) knlGS:0000000000000000
[  376.998896] CS:  0010 DS: 0000 ES: 0000 CR0: 0000000080050033
[  376.998900] CR2: 0000000000000000 CR3: 000000008a40a002 CR4: 00000000000606f0
[  376.998904] Call Trace:
[  376.998930]  ath11k_core_qmi_firmware_ready+0x35/0x4c0 [ath11k]
[  376.998949]  ath11k_core_restart+0x223/0x390 [ath11k]
[  376.998963]  process_one_work+0x166/0x370
[  376.998975]  worker_thread+0x49/0x3e0
[  376.998983]  kthread+0xf8/0x130
[  376.998991]  ? rescuer_thread+0x300/0x300
[  376.998997]  ? kthread_bind+0x10/0x10
[  376.999005]  ret_from_fork+0x35/0x40

Signed-off-by: Baochen Qiang <bqiang@codeaurora.org>
---
 drivers/net/wireless/ath/ath11k/ahb.c  |  2 +-
 drivers/net/wireless/ath/ath11k/core.c |  4 ++--
 drivers/net/wireless/ath/ath11k/hal.c  | 20 ++++++++++++++++++--
 drivers/net/wireless/ath/ath11k/hal.h  |  2 +-
 drivers/net/wireless/ath/ath11k/pci.c  |  6 +-----
 5 files changed, 23 insertions(+), 11 deletions(-)

diff --git a/drivers/net/wireless/ath/ath11k/ahb.c b/drivers/net/wireless/ath/ath11k/ahb.c
index 8ed2a1b..167e82c 100644
--- a/drivers/net/wireless/ath/ath11k/ahb.c
+++ b/drivers/net/wireless/ath/ath11k/ahb.c
@@ -882,7 +882,7 @@ static int ath11k_ahb_probe(struct platform_device *pdev)
 	if (ret)
 		goto err_core_free;
 
-	ret = ath11k_hal_srng_init(ab);
+	ret = ath11k_hal_init(ab);
 	if (ret)
 		goto err_core_free;
 
diff --git a/drivers/net/wireless/ath/ath11k/core.c b/drivers/net/wireless/ath/ath11k/core.c
index 3ee2c71..e4db898 100644
--- a/drivers/net/wireless/ath/ath11k/core.c
+++ b/drivers/net/wireless/ath/ath11k/core.c
@@ -758,7 +758,7 @@ static int ath11k_core_reconfigure_on_crash(struct ath11k_base *ab)
 
 	ab->free_vdev_map = (1LL << (ab->num_radios * TARGET_NUM_VDEVS)) - 1;
 
-	ret = ath11k_hal_srng_init(ab);
+	ret = ath11k_hal_init(ab);
 	if (ret)
 		return ret;
 
@@ -1173,7 +1173,7 @@ int ath11k_core_resume(struct ath11k_base *ab)
 
 	set_bit(ATH11K_FLAG_CORE_STARTING, &ab->dev_flags);
 	init_completion(&ab->fw_mac_restart);
-	ath11k_hal_srng_init(ab);
+	ath11k_hal_init(ab);
 	ath11k_hif_power_up(ab);
 
 	return ret;
diff --git a/drivers/net/wireless/ath/ath11k/hal.c b/drivers/net/wireless/ath/ath11k/hal.c
index 17121d4..47620f3 100644
--- a/drivers/net/wireless/ath/ath11k/hal.c
+++ b/drivers/net/wireless/ath/ath11k/hal.c
@@ -1289,7 +1289,7 @@ static void ath11k_hal_srng_init_config(struct ath11k_base *ab)
 		HAL_SEQ_WCSS_UMAC_TCL_REG + HAL_TCL_STATUS_RING_HP;
 }
 
-int ath11k_hal_srng_init(struct ath11k_base *ab)
+static int ath11k_hal_srng_init(struct ath11k_base *ab)
 {
 	struct ath11k_hal *hal = &ab->hal;
 	int ret;
@@ -1315,7 +1315,23 @@ int ath11k_hal_srng_init(struct ath11k_base *ab)
 err_hal:
 	return ret;
 }
-EXPORT_SYMBOL(ath11k_hal_srng_init);
+
+int ath11k_hal_init(struct ath11k_base *ab)
+{
+	int ret;
+
+	ret = ath11k_hal_srng_init(ab);
+	if (ret)
+		goto err;
+	ret = ath11k_hal_rx_ops_init(ab);
+	if (ret)
+		goto err;
+
+	return 0;
+err:
+	return ret;
+}
+EXPORT_SYMBOL(ath11k_hal_init);
 
 void ath11k_hal_srng_deinit(struct ath11k_base *ab)
 {
diff --git a/drivers/net/wireless/ath/ath11k/hal.h b/drivers/net/wireless/ath/ath11k/hal.h
index 447cbc5..bc806bc 100644
--- a/drivers/net/wireless/ath/ath11k/hal.h
+++ b/drivers/net/wireless/ath/ath11k/hal.h
@@ -919,7 +919,7 @@ void ath11k_hal_srng_access_begin(struct ath11k_base *ab,
 int ath11k_hal_srng_setup(struct ath11k_base *ab, enum hal_ring_type type,
 			  int ring_num, int mac_id,
 			  struct hal_srng_params *params);
-int ath11k_hal_srng_init(struct ath11k_base *ath11k);
+int ath11k_hal_init(struct ath11k_base *ath11k);
 void ath11k_hal_srng_deinit(struct ath11k_base *ath11k);
 void ath11k_hal_dump_srng_stats(struct ath11k_base *ab);
 void ath11k_hal_srng_get_shadow_config(struct ath11k_base *ab,
diff --git a/drivers/net/wireless/ath/ath11k/pci.c b/drivers/net/wireless/ath/ath11k/pci.c
index 1d004c4..780840d 100644
--- a/drivers/net/wireless/ath/ath11k/pci.c
+++ b/drivers/net/wireless/ath/ath11k/pci.c
@@ -1441,11 +1441,7 @@ static int ath11k_pci_probe(struct pci_dev *pdev,
 	if (ret)
 		goto err_pci_unregister_mhi;
 
-	ret = ath11k_hal_srng_init(ab);
-	if (ret)
-		goto err_pci_unregister_mhi;
-
-	ret = ath11k_hal_rx_ops_init(ab);
+	ret = ath11k_hal_init(ab);
 	if (ret)
 		goto err_pci_unregister_mhi;
 
-- 
1.9.1

